/*  Diagnostic output for G-B-H accelerations				*/
/*  Source file:  acdiag.cs		Prototypes:  acdiag.hs		*/
/*  Uses declarations in gbh.hs.					*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <cscomm.h>
#include "gbh.hs"

/*  Diagnostic printing for Accel - 3 ints, 4 floats	*/

void Adiag(int:Particles *i1, int:Particles *i2, int:Particles *i3,
	   float:Particles *f1, float:Particles *f2,
	   float:Particles *f3, float:Particles *f4		  )
 { int u;
   for ( u = 0; u < N; u++ )
    printf("%4d  %4d  %4d  %4d  %12.5e  %12.5e  %12.5e  %12.5e\n",
	   u, [u]*i1, [u]*i2, [u]*i3, [u]*f1, [u]*f2, [u]*f3, [u]*f4);
 }


/*  Print summary of acceleration statistics	*/

void Asummary(int acyc, double nodex, double nodea, char prp)
 { double tcyc;
   tcyc = nodex + nodea + N;	/* total processor-cycles	*/
   printf("Cycles: %d   Accepted: %g   Rejected: %g   Total: %g\n",
		  acyc,          nodea,         nodex,      tcyc   );
   printf("Activity ratio:  %4.2f%%", 100.0*tcyc/(((double)acyc)*N));
   printf("   Tree formed using X%c\n", prp);
 }
